import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'package:rlstyles/main.dart';

class TextInputView extends HookWidget {
  final bool? autofocus;
  final Function()? onFocus;
  final Function()? onBlur;
  // 最大字数
  final int? maxlength;
  // 键盘类型
  final TextInputType? keyboardType;
  final String? placeholder;
  const TextInputView(
      {Key? key,
      this.autofocus = false,
      this.onFocus,
      this.onBlur,
      this.maxlength = -1,
      this.keyboardType,
      this.placeholder = ''})
      : super(key: key);
  @override
  Widget build(BuildContext context) {
    renderInput() {
      return CupertinoSearchTextField(
        padding: const EdgeInsetsDirectional.fromSTEB(0.0, 0.0, 0.0, 0.0),
        suffixIcon: Icon(
          Icons.search,
          color: Colors.white.withOpacity(0.0),
        ),
        prefixIcon: Container(),
        // suffixIcon: const Icon(Icons.track_changes),
        backgroundColor: Colors.transparent,
        placeholder: placeholder,
      );
    }

    return renderInput();
    // return renderPlaceholder();
  }
}
